#include <windows.h>
#include "pthread.h"
#include <iostream>

using namespace std;

static ULONG actual_time;
int error_code;
static void *(*Csharp_Error) (char *text);
static void *(*Csharp_NewData)(void);

//-----------------------------------------------------------------------------
// Struct: Data to be received
//-----------------------------------------------------------------------------
typedef  struct
{
	UINT time_datarx[6];
	UINT messagetype_datarx;
	UINT cantype_datarx;
	UINT id_rx[8];
	UINT dlc_rx;
	UINT datarx[16];
	UINT crc_datarx[2];
}CAN_DATA_RX;

//-----------------------------------------------
//Daten an RS232 senden
//-----------------------------------------------
typedef struct
{
	UCHAR messagetype_datatx;
	UCHAR cantype_datatx;
	UCHAR id_tx[8];
	UCHAR dlc_tx;
	UCHAR datatx[16];
	UCHAR crc_datatx[2];
}CAN_DATA_TX;

typedef struct 
{
	UINT time_error[6];
	UINT cantype_error;
	UINT errortype[2];
}ERROR_STRING;

/** Write the system error string corresponding to the given error code out to the console.
 * @param[in]   Result  Error code.
 */
void    OutSystemError( HRESULT Result ) ;
/** Read a single character from hPort & return into pData.
 * NOTE:  pData is pre-allocated by the caller.
 * @param[in]   hPort   Handle to the open port (assumed Serial port).
 * @param[out]  pData   Pointer to memory allocated to stick the read bytes into.
 */

HRESULT         Result          = S_OK ;
HANDLE          hPort           = INVALID_HANDLE_VALUE ;  // The handle to the port.
char           *Port_Name       = "COM1" ;                // Serial port name.
DCB             PortDCB         = { 0 } ;                 // Device control block (controls port settings).
LPCOMMTIMEOUTS  lpCommTimeouts  = NULL ;                  // Timeout structure.

DWORD   BaudRate = CBR_19200 ;
BYTE    Parity   = NOPARITY ;
BYTE    StopBits = ONESTOPBIT ;
BYTE    ByteSize = 8 ;

// All 0 = wait forever.
DWORD   ReadIntervalTimeout         = 0 ;
DWORD   ReadTotalTimeoutMultiplier  = 0 ;
DWORD   ReadTotalTimeoutConstant    = 0 ;
DWORD   WriteTotalTimeoutMultiplier = 0 ;
DWORD   WriteTotalTimeoutConstant   = 0 ;

BYTE    Read_Buffer                 = 0x00 ;
 

